import java.util.ArrayList;

/**
 * @author Marco Kümmel 
 * @version Juni 2024
 */
public class Damenproblem
{
    private DATENTYP feld;
    //[Reihe][Spalte]
    
    
    /**
     * Konstruktor für Objekte der Klasse Damenproblem
     */
    public Damenproblem()
    {
        //Initialisierung:
        //feld = 
    }

    public void starte8DamenProblem() {
        reihe(0);
    }
    
    /**
     * Rekursiver Backtrracking-Algorithmus
     */
    private void reihe(int reihe) {
        // Implementiere hier den Pseudocode
    }
    
    
    
    /**
     * Prüfe, ob das Feld auf den DIAGONALEN kollisionsfrei ist
     */
    private boolean kollisionsfrei() {
        /** Hintergrund zur Vorgehensweise:
         * Auf einer Diagonalen von links oben nach rechts unten ist die Differenz der 
         * x- und y-Koordinate jeweils identisch.
         * Auf einer Diagonalen von rechts oben nach links unten ist die Summe der 
         * x- und y-Koordinate jeweils identisch.
         */
        
        // speichere die Summe der x-&y-Koordinaten für jede Dame
        ArrayList<Integer> summen = new ArrayList<>();
        // speichere die Differenz der x-&y-Koordinaten für jede Dame
        ArrayList<Integer> differenzen = new ArrayList<>();
        
        for (int reihe = 0; reihe < 8; reihe++) {
            for (int spalte = 0; spalte < 8; spalte++) {
                if (feld[reihe][spalte]) {
                    summen.add(reihe + spalte);
                    differenzen.add(reihe-spalte);
                }
            }
        }
        
        // Überprüfe, ob eine Summe doppelt vorkommt
        for (int i = 0; i < summen.size()-1; i++) {
            for (int j = i+1; j < summen.size(); j++) {
                if (summen.get(i) == summen.get(j)) {
                    return false;
                }
            }
        }
        
        // Überprüfe, ob eine Differenz doppelt vorkommt
        for (int i = 0; i < differenzen.size()-1; i++) {
            for (int j = i+1; j < differenzen.size(); j++) {
                if (differenzen.get(i) == differenzen.get(j)) {
                    return false;
                }
            }
        }
        
        return true;
    }
}
